> ## Documentation Index
> Fetch the complete documentation index at: https://domoinc-openapi-sync-dataflows.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a DataSet

> Creates a new DataSet in your Domo instance. Once a DataSet has been created, data can be imported into the DataSet.



## OpenAPI

````yaml /openapi/platform/dataset.yaml POST /v1/datasets
openapi: 3.0.0
info:
  title: DataSet API
  description: >
    ## The DataSet Object


    ---


    The DataSet API allows you to create, replace, append to, export, and manage
    DataSets, as well as manage data permissions for DataSets within Domo. Most
    of its calls return a DataSet object.



    <!-- theme: info -->


    > #### Best Practice

    >

    > The DataSet API should be used to create and update small DataSets that
    occasionally need their data updated. For creating and updating massive,
    constantly changing, or rapidly growing DataSets, the Stream API is
    recommended.


    <!-- theme: info -->


    > #### Permissions

    >

    > To update or write to a DataSet via API, you must have the Manage DataSet
    grant enabled.


    ### Attributes


    | Property Name | Type | Description |

    | --- | --- | --- |

    | id | String | ID of the DataSet |

    | name | String | Name of the DataSet |

    | description | String | Description of DataSet |

    | owner.id | String | ID of the owner |

    | owner.name | String | Name of the owner |

    | columns | Number | The number of columns currently in the DataSet |

    | createdAt | String | An ISO-8601 representation of the creation date of
    the DataSet |

    | updatedAt | String | AN ISO-8601 representation of the time the DataSet
    was last updated |

    | dataCurrentAt | String | An ISO-8601 representation of the time the
    DataSet was current |

    | schema | Object | The current schema associated with this DataSet |

    | schema.columns | Array | Array of columns in the DataSet |

    | schema.columns\[\].name | String | Column name in the DataSet schema |

    | schema.columns\[\].type | String | Column type in the DataSet schema.
    Valid types are STRING, DECIMAL, LONG, DOUBLE, DATE, DATETIME. |

    | pdpEnabled | Boolean | Indicates if PDP \[Personalized Data Permission\]
    policy filtering on data is active on this DataSet |

    | policies | Array | List of policies attached to DataSet |

    | policies\[\].filters\[\].column | String | Name of the column to filter on
    |

    | policies\[\].filters\[\].not | Boolean | Determines if NOT is applied to
    the filter operation |

    | policies\[\].filters\[\].operator | String | Matching operator (EQUALS) |

    | policies\[\].filters\[\].values\[\] | String | Values to filter on |

    | policies\[\].groups | Array | List of group IDs the policy applies to |

    | policies\[\].id | Number | ID of the Policy |

    | policies\[\].name | String | Name of the Policy |

    | policies\[\].type | String | Type of policy (user or system) |

    | policies\[\].users | Array | List of user IDs the policy applies to |

    | rows | Number | The number of rows currently in the DataSet |
  version: 1.0.0
servers:
  - url: https://api.domo.com
    description: Domo API
security:
  - bearerAuth: []
paths:
  /v1/datasets:
    post:
      summary: Create a DataSet
      description: >-
        Creates a new DataSet in your Domo instance. Once a DataSet has been
        created, data can be imported into the DataSet.
      requestBody:
        content:
          application/json:
            schema:
              type: object
              x-examples:
                Example 1:
                  name: Leonhard Euler Party
                  description: Mathematician Guest List
                  rows: 0
                  schema:
                    columns:
                      - type: STRING
                        name: Friend
                      - type: STRING
                        name: Attending
              required:
                - name
                - schema
              properties:
                name:
                  type: string
                  description: Name of the DataSet to create
                description:
                  type: string
                  description: Description of DataSet to create
                schema:
                  type: object
                  description: The current schema associated with this DataSet
                  required:
                    - columns
                  properties:
                    columns:
                      type: array
                      description: Array of columns in the DataSet
                      items:
                        type: object
                        required:
                          - type
                          - name
                        properties:
                          type:
                            type: string
                            description: >-
                              Column type in the DataSet schema. Valid types are
                              `STRING`, `DECIMAL`, `LONG`, `DOUBLE`, `DATE`, and
                              `DATETIME`
                          name:
                            type: string
                            description: Column name in the DataSet schema
            examples:
              Example 1:
                value:
                  name: Leonhard Euler Party
                  description: Mathematician Guest List
                  rows: 0
                  schema:
                    columns:
                      - type: STRING
                        name: Friend
                      - type: STRING
                        name: Attending
        description: ''
      responses:
        '201':
          description: >-
            Returns a DataSet object when successful. The returned object will
            have DataSet attributes based on the information provided when the
            DataSet was created.
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                  name:
                    type: string
                  description:
                    type: string
                  rows:
                    type: integer
                  columns:
                    type: integer
                  schema:
                    type: object
                    properties:
                      columns:
                        type: array
                        items:
                          type: object
                          properties:
                            type:
                              type: string
                            name:
                              type: string
                  owner:
                    type: object
                    properties:
                      id:
                        type: integer
                      name:
                        type: string
                  createdAt:
                    type: string
                  updatedAt:
                    type: string
                x-examples:
                  Example 1:
                    id: 4405ff58-1957-45f0-82bd-914d989a3ea3
                    name: Leonhard Euler Party
                    description: Mathematician Guest List
                    rows: 0
                    columns: 0
                    schema:
                      columns:
                        - type: STRING
                          name: Friend
                        - type: STRING
                          name: Attending
                    owner:
                      id: 27
                      name: DomoSupport
                    createdAt: '2016-06-21T17:20:36Z'
                    updatedAt: '2016-06-21T17:20:36Z'
              examples:
                Example 1:
                  value:
                    id: 4405ff58-1957-45f0-82bd-914d989a3ea3
                    name: Leonhard Euler Party
                    description: Mathematician Guest List
                    rows: 0
                    columns: 0
                    schema:
                      columns:
                        - type: STRING
                          name: Friend
                        - type: STRING
                          name: Attending
                    owner:
                      id: 27
                      name: DomoSupport
                    createdAt: '2016-06-21T17:20:36Z'
                    updatedAt: '2016-06-21T17:20:36Z'
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````